#include <stdio.h>
#include <math.h>

class PointSet{

public:
  double **_point;
  int _pointN;
  int *index;
  
 public:
  PointSet(){
    _pointN = 0;
    _point = NULL;
  }
  
  ~PointSet(){
    if(_point != NULL){
      for(int i=0;i<_pointN;i++)delete _point[i];
      delete[] _point;
    }
    delete [] index;
  }
  
  void setPointSize(int N){
    _pointN = N;
    _point = new double* [N];
    for(int i=0;i<N;i++){
      _point[i] = new double[3];
      
    }
    index = new int[N];
  }
  
  inline void swapIndex(int i, int j){
    double tmp = _point[i][0];
    _point[i][0] = _point[j][0];
    _point[j][0] = tmp;
    
    tmp = _point[i][1];
    _point[i][1] = _point[j][1];
    _point[j][1] = tmp;
    
    tmp = _point[i][2];
    _point[i][2] = _point[j][2];
    _point[j][2] = tmp;
    int dtmp = index[i];
    index[i] = index[j];
    index[j] = dtmp;
  }
  
  void setPoint(int i, double x, double y, double z){
    _point[i][0] = x;
    _point[i][1] = y;
    _point[i][2] = z;
    index[i] = i;
  }
    
  
  void bound(double min[], double max[], int start, int end){
    min[0] = _point[0][0];min[1] = _point[0][1];min[2] = _point[0][2];
    max[0] = _point[0][0];max[1] = _point[0][1];max[2] = _point[0][2];
    //min[0] = min[1] = min[2] = 10000000000.0;
    //max[0] = max[1] = max[2] = -10000000000.0;
    
    for(int i=start; i<end; i++){
      double *p = _point[i];
      if(p[0] < min[0])
        min[0] = p[0];
      if(p[0] > max[0])
        max[0] = p[0];
      
      if(p[1] < min[1])
        min[1] = p[1];
      if(p[1] > max[1])
        max[1] = p[1];
      
      if(p[2] < min[2])
        min[2] = p[2];
      if(p[2] > max[2])
        max[2] = p[2];
    }
  }
  
};

