#include<stdio.h>
#include<math.h>
#include<stdlib.h>
#include<unistd.h>
#include"IDList.h"
#include"IDSet.h"
#include"Point3d.h"
#include"PointTool.h"
#include"PointSet.h"
#include"AxisKdTree.h"
#include"GaussianRN.h"
#include"SvdSolve.h"
#include"RBF.h"
#include"Polyhedron.h"

#define PI 3.1415926535897932385

void Polyhedron::Gaussian(Point3d **in,Point3d **out,double sig2,double radi){
  int i,j;
  
  //Gaussian 
  
  
  int listN=0,*index_list;
  double c[3];
  double dv,dist,dx,dy,dz;
  double sig22H = 1.0/((2.0*sig2*sig2));
  double dsum;
  for(i=0;i<numberV;i++){
    c[0] = in[i]->x;
    c[1] = in[i]->y;
    c[2] = in[i]->z;
    tree->collectPointIndexInSphere(index_list,listN,c,radi);
    dc[0]->x = 0.0;
    dc[0]->y = 0.0;
    dc[0]->z = 0.0;
    dsum=0.0;
    
    for(j=0;j<listN;j++){
      
      dist = PT->Distance(in[i],cpoint[ps->index[index_list[j]]]);
      dv = exp(-(dist*dist)*sig22H);
      dsum+=dv;
      
      dc[0]->x += dv*cpoint[ps->index[index_list[j]]]->x;
      dc[0]->y += dv*cpoint[ps->index[index_list[j]]]->y;
      dc[0]->z += dv*cpoint[ps->index[index_list[j]]]->z;
    }
    
    if(dsum!=0.0&&listN!=0){
      out[i]->x = dc[0]->x/dsum;
      out[i]->y = dc[0]->y/dsum;
      out[i]->z = dc[0]->z/dsum;
      
    }else{
      out[i]->x = point[i]->x;
      out[i]->y = point[i]->y;
      out[i]->z = point[i]->z;
      
    }
   
    
  }
  
}

void Polyhedron::Similarity(int ID,double sig3,double *sim){

 
  int i,j,k;

  
  IDList **LHead = new IDList* [numberV];
  IDList **LTail = new IDList* [numberV];
  Point3d *t1 = new Point3d(0.0,0.0,0.0);
  Point3d *t2 = new Point3d(0.0,0.0,0.0);
  
  
    double radi2 = 2.0*sig3;
  int listN=0,*index_list;
  double c[3];
  makeNormals(point);
  
  for(i=0;i<numberV;i++){
    
    
   
    neighborL[i]=0;
    
    
    LHead[i] = new IDList();
    LTail[i] = new IDList();
    LHead[i]->next = LTail[i];
    LTail[i]->back = LHead[i];
  }
  
  double dv,dist,dist1,dx,dy,cx,cy,pu,pv;
  IDList *now;
  int nrot=0;
  double dVal,dinn,Iy,dsum;
  tree = new AxisKdTree(ps);
  
  
  for(i=0;i<numberV;i++){
    c[0] = point[i]->x;
    c[1] = point[i]->y;
    c[2] = point[i]->z;
    
    tree->collectPointIndexInSphere(index_list,listN,c,radi2);
    
    
    
    for(j=0;j<listN;j++){
      IDtool->AppendVF(ps->index[index_list[j]],LTail[i]);
      neighborL[i]++;
          
      
    }
    
  }
  
  
  double minval=0.0;
  double IIy,sigma33 = 1.0/(2.0*sig3*sig3);
  int dlk;
  
  
  RBF *myRBF = new RBF(neighborL[ID]);
  
  PT->setVitrualTangents(normal[ID],t1,t2);
    
  now = LHead[ID];
  for(k=0;k<neighborL[ID];k++){
    
    now = next(now);
    PT->makeVector(dc[2],point[ID],point[now->ID]);
    myRBF->setPoint(k,PT->InnerProduct(dc[2],t1),PT->InnerProduct(dc[2],t2),PT->InnerProduct(dc[2],normal[ID]));
    
  }
  myRBF->Fitting();
  
  
  double minVal,Val;
  double value[4];
  for(i=0;i<numberV;i++){
    sim[i]=0.0;
    minVal=Similariry(ID,i,myRBF,t1,t2,sigma33,LHead[i],LTail[i]);
    sim[i]=exp(-minVal);
    
  }
  
    
  IDtool->CleanNeighborL(LHead,LTail,numberV);
}





double Polyhedron::Similariry(int i,int nowID,RBF *myRBF,Point3d *t1,Point3d *t2,double sigma33,IDList *LHead,IDList *LTail){
  double similar=0.0;
  double IIy,dU,dV;

  IDList * now2 = LHead;
  while(next(now2)!=LTail){
    now2 = next(now2);
    PT->makeVector(dc[3],point[i],point[now2->ID]);
    IIy = PT->InnerProduct(dc[3],normal[i]);
        
    PT->makeVector(dc[8],point[nowID],point[now2->ID]);
    dU = PT->InnerProduct(dc[8],t1);
    dV = PT->InnerProduct(dc[8],t2);
    
    
    double ddvall = dU*dU+dV*dV;
    double approxIy = myRBF->DEva(dU,dV);
    
    double ddis = IIy-approxIy;
    
    similar += exp(-ddvall*sigma33)*ddis*ddis;
  }
  
  
  return similar;
}


void Polyhedron::NLMean(double sig1,double sig2,double sig3){
  int i,j,k;
  IDList **Head = new IDList* [numberV];
  IDList **Tail = new IDList* [numberV];
  IDList **LHead = new IDList* [numberV];
  IDList **LTail = new IDList* [numberV];
  
  
  IDList *now;
  
  
 
  
  double radi = 2.0*sig2;
  double radi2 = 2.0*sig3;
  int listN=0,*index_list;
  double c[3];
    
  for(i=0;i<numberV;i++){
    neighborL[i]=0;
    neighborI[i]=0;
    Head[i] = new IDList();
    Tail[i] = new IDList();
    Head[i]->next = Tail[i];
    Tail[i]->back = Head[i];
    LHead[i] = new IDList();
    LTail[i] = new IDList();
    LHead[i]->next = LTail[i];
    LTail[i]->back = LHead[i];
  }
  
  double dv,dist,dist1,dx,dy,cx,cy;
  double sig22 = 1.0/((2.0*sig2*sig2));
  double sig12 = 1.0/((2.0*sig1*sig1));
  makeNormals(point);
  double dVal,dinn,Iy,dsum;
  tree = new AxisKdTree(ps);
  for(i=0;i<numberV;i++){
    c[0] = point[i]->x;
    c[1] = point[i]->y;
    c[2] = point[i]->z;
    tree->collectPointIndexInSphere(index_list,listN,c,radi);
    for(j=0;j<listN;j++){
      IDtool->AppendVF(ps->index[index_list[j]],Tail[i]);
      neighborI[i]++;
    }
    tree->collectPointIndexInSphere(index_list,listN,c,radi2);
    for(j=0;j<listN;j++){
      IDtool->AppendVF(ps->index[index_list[j]],LTail[i]);
      neighborL[i]++;
    }
  }
  

  
  IDList *now2;
  double IIy,sigma33 = 1.0/(2.0*sig3*sig3);
  int dlk;
  double minVal,Val;
  
  for(i=0;i<numberV;i++){
    
    dVal=0.0;
    dsum=0.0;
    if(neighborL[i]>1){
      
      RBF *myRBF = new RBF(neighborL[i]);
      PT->setVitrualTangents(normal[i],t1,t2);
      now = LHead[i];
      for(k=0;k<neighborL[i];k++){
	now = next(now);
	PT->makeVector(dc[2],point[i],point[now->ID]);
	myRBF->setPoint(k,PT->InnerProduct(dc[2],t1),PT->InnerProduct(dc[2],t2),PT->InnerProduct(dc[2],normal[i]));
      }
      myRBF->Fitting();
      
      
      now = Head[i];
      while(next(now)!=Tail[i]){
	now = next(now);
	if(i==now->ID){
	  dv=1.0;
	  Iy=0.0;
	}else{
	  dist1=0.0;
	  PT->makeVector(dc[2],point[i],point[now->ID]);
	  Iy = PT->InnerProduct(dc[2],normal[i]);
	  minVal = Similariry(i,now->ID,myRBF,t1,t2,sigma33,LHead[now->ID],LTail[now->ID]);
	  dv = exp(-(minVal*sig12));
	}
	dsum+=dv;
	dVal += dv*Iy;
      }
      delete myRBF;
      
    }
    if(dsum!=0.0){
      dVal = dVal/dsum;
      cpoint[i]->x = point[i]->x+normal[i]->x*dVal;
      cpoint[i]->y = point[i]->y+normal[i]->y*dVal;
      cpoint[i]->z = point[i]->z+normal[i]->z*dVal;
    }else{
      cpoint[i]->x = point[i]->x;
      cpoint[i]->y = point[i]->y;
      cpoint[i]->z = point[i]->z;
      
    }
    
  }
  
  for(i=0;i<numberV;i++){
    point[i]->x = cpoint[i]->x;
    point[i]->y = cpoint[i]->y;
    point[i]->z = cpoint[i]->z;
    ps->setPoint(i,point[i]->x,point[i]->y,point[i]->z);
      }
  
  
   IDtool->CleanNeighborL(Head,Tail,numberV);
   IDtool->CleanNeighborL(LHead,LTail,numberV);
   delete tree;tree=NULL;
   
}

void Polyhedron::savesimilarity(char *filename){
  int i;
  FILE *in = fopen(filename,"w");
  fprintf(in,"%d\n",numberV);
  for(i=0;i<numberV;i++){
    fprintf(in,"%lf\n",simi[i]);
  }
  fclose(in);
}

void Polyhedron::savepoint(char *filename){
  int i;
  FILE *in = fopen(filename,"w");
  fprintf(in,"%d\n",numberV);
  for(i=0;i<numberV;i++){
    fprintf(in,"%lf %lf %lf\n",point[i]->x,point[i]->y,point[i]->z);
  }
  fclose(in);
}


void Polyhedron::readmesh(char *filename){
  int i,j;
  FILE *in = fopen(filename,"r");
  fscanf(in,"%d %d %d %d",&Stype,&SNum,&pickID,&opti);
  fscanf(in,"%lf %lf %lf",&sig1,&sig2,&sig3);
  me=0.0;
  fscanf(in,"%d",&numberV);
  fscanf(in,"%d",&numberF);
  Face = new int* [numberF];
  point = new Point3d* [numberV];
  normal = new Point3d* [numberV];
  
  neighborL = new int[numberV];
  neighborI = new int[numberV];
  t1 = new Point3d(0.0,0.0,0.0);
  t2 = new Point3d(0.0,0.0,0.0);
  
  simi = new double[numberV];
  cpoint = new Point3d* [numberV];
  ps = new PointSet();
  ps->setPointSize(numberV);
  double dx,dy,dz;
  
  
  for(i=0;i<numberV;i++){simi[i]=0.0;
    fscanf(in,"%lf %lf %lf",&dx,&dy,&dz);
    
    cpoint[i] = new Point3d(dx,dy,dz);
    
    point[i] = new Point3d(dx,dy,dz);
    normal[i] = new Point3d(0.0,0.0,0.0);
    ps->setPoint(i,point[i]->x,point[i]->y,point[i]->z);
  }
  int di,dj,dk;
  
  for(i=0;i<numberF;i++){
    
    fscanf(in,"%d %d %d",&di,&dj,&dk);
    
    Face[i] = new int[3];
    Face[i][0] = di;
    Face[i][1] = dj;
    Face[i][2] = dk;
    me += (PT->Distance(point[Face[i][0]],point[Face[i][1]])+PT->Distance(point[Face[i][1]],point[Face[i][2]])+PT->Distance(point[Face[i][2]],point[Face[i][0]]))/3.0;
  }
  fclose(in);
  me /= ((double)(numberF));
  if(me==0.0)me=1.0;
  double osig1 = sig1;
  double osig2 = sig2;
  double osig3 = sig3;
  
  sig1 *= me;
  sig2 *= me;
  sig3 *= me;
  
  

  
  
  if(Stype==0){
    
    Similarity(pickID,sig3,simi);
  }else if(Stype==1){
    makeNormals(point);
    
    addGaussianNoizeNormal(0.0,sig1);
  }else{
    //SNR
     for(int kkk=0;kkk<SNum;kkk++){
    double dummysig1 = sig1;
    
    
    if(opti==1){
      
      //picked height variation
      dummysig1 = getHeightVariation(pickID);
    }else if(opti==2){
      //average height variation
      dummysig1 = getAverageHeightVariation();
    }
    sig1 = dummysig1;  
    
    //NL-mean 
    
      //molification
      //Boomgaard and Weijer IEEE 2002
      NLMean(sig1,sig2,sig3);
      
      if(kkk==SNum-1)break;
      me = 0.0;
      for(i=0;i<numberF;i++){
	me += (PT->Distance(point[Face[i][0]],point[Face[i][1]])+PT->Distance(point[Face[i][1]],point[Face[i][2]])+PT->Distance(point[Face[i][2]],point[Face[i][0]]))/3.0;
      }
      me /= ((double)(numberF));
      if(me==0.0)me=1.0;
      sig1 = me*osig1;
      sig2 = me*osig2;
      sig3 = me*osig3;
      
      
    }
    
  }
  
}
double Polyhedron::getHeightVariation(int pickid){
  double dsig=0.0;
  int i,j,k;
  double radi2 = 2.0*sig1;
  int listN=0,*index_list;
  double c[3];
  
  makeNormals(point);
  double Iy;
  tree = new AxisKdTree(ps);
  int nowID;
  
  dsig=0.0;
  c[0] = point[pickid]->x;
  c[1] = point[pickid]->y;
  c[2] = point[pickid]->z;
    
  
  double dsum=0.0;
  double sdiv=0.0;
  
  tree->collectPointIndexInSphere(index_list,listN,c,radi2);
  for(k=0;k<listN;k++){
    nowID = ps->index[index_list[k]];
    
    PT->makeVector(dc[2],point[pickid],point[nowID]);
    Iy = PT->InnerProduct(dc[2],normal[pickid]);
    dsum+=Iy;sdiv+=Iy*Iy;
  }
  dsig = dsum;
  dsig /= ((double)(listN));
  sdiv /= ((double)(listN));
  sdiv -= dsig*dsig;
  dsig = sqrt(PI*sdiv);
  if(dsig<0.0)return 1.0;
  return dsig;
}

double Polyhedron::getAverageHeightVariation(){
  double dsig=0.0;
  
  int i,j,k;

  
  double radi2 = 2.0*sig1;
  int listN=0,*index_list;
  double c[3];
  
  makeNormals(point);
  double Iy;
  tree = new AxisKdTree(ps);
  int nowID;
  
  dsig=0.0;
  double advi=0.0;
  for(i=0;i<numberV;i++){
    c[0] = point[i]->x;
    c[1] = point[i]->y;
    c[2] = point[i]->z;
    
    double dsum=0.0;
    tree->collectPointIndexInSphere(index_list,listN,c,radi2);
    for(k=0;k<listN;k++){
      nowID = ps->index[index_list[k]];
      
      PT->makeVector(dc[2],point[i],point[nowID]);
      Iy = PT->InnerProduct(dc[2],normal[i]);
      dsum+=Iy;
    }
    if(listN>0)dsum /= ((double)(listN));
    
    
    dsig += dsum;
    advi += dsum*dsum;
  } 
  
  dsig /= ((double)(numberV));
  advi /= ((double)(numberV));
  advi -= dsig*dsig;
  dsig = sqrt(PI*advi);
  if(dsig<0.0)return 1.0;
  return dsig;
  
}
void Polyhedron::addGaussianNoizeNormal(double mean,double sig){
  int i,j;
  double dv;
  long idum = -1;
  GaussianRN *myrand = new GaussianRN(idum);
  for(i=0;i<numberV;i++){
    dv = myrand->gasdev();
    
    point[i]->x +=(mean + sig*dv)*normal[i]->x;
    point[i]->y +=(mean + sig*dv)*normal[i]->y;
    point[i]->z +=(mean + sig*dv)*normal[i]->z;
  }    
  delete myrand;
}


void Polyhedron::makeNormals(Point3d **in){
  int i,j;
  for(i=0;i<numberV;i++){
    normal[i]->x = 0.0;
    normal[i]->y = 0.0;
    normal[i]->z = 0.0;
  }
  double d0,d1,d2,dval;
  for(i=0;i<numberF;i++){
    
    PT->makeVector(dc[0],in[Face[i][1]],in[Face[i][0]]);
    PT->makeVector(dc[1],in[Face[i][2]],in[Face[i][0]]);
    PT->CrossVector(dc[2],dc[0],dc[1]);
    d0 =  PT->Point3dSize(dc[0]);if(d0==0.0)d0=1.0;
    d1 =  PT->Point3dSize(dc[1]);if(d1==0.0)d1=1.0;
    d2 =  PT->Distance(in[Face[i][1]],in[Face[i][2]]);if(d2==0.0)d2=1.0;
    dval = 1.0/(d0*d0*d1*d1);
    
    
    normal[Face[i][0]]->x += dval*dc[2]->x;
    normal[Face[i][0]]->y += dval*dc[2]->y;
    normal[Face[i][0]]->z += dval*dc[2]->z;
    dval = 1.0/(d0*d0*d2*d2);
    
    normal[Face[i][1]]->x += dval*dc[2]->x;
    normal[Face[i][1]]->y += dval*dc[2]->y;
    normal[Face[i][1]]->z += dval*dc[2]->z;
    dval = 1.0/(d1*d1*d2*d2);
    
    normal[Face[i][2]]->x += dval*dc[2]->x;
    normal[Face[i][2]]->y += dval*dc[2]->y;
    normal[Face[i][2]]->z += dval*dc[2]->z;
    
    
  }
  for(i=0;i<numberV;i++){
    PT->Normalize3D(normal[i]);
  }
}

void Polyhedron::deletememory(){
  int i,j;
 
  delete ps;
  for(i=0;i<numberV;i++){
    delete point[i];
    delete cpoint[i];
    delete normal[i];
  }
  delete [] neighborL;
  delete [] neighborI;
  delete t1;
  delete t2;
  delete [] cpoint;
  delete [] normal;
  delete [] point;
    
  for(i=0;i<numberF;i++){
   
   
    delete [] Face[i];
  }
  delete [] Face;
  delete [] simi;
}
#undef PI
