import java.io.*;
import java.applet.Applet;
import java.awt.FlowLayout;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.Hashtable;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.loaders.Scene;
import com.sun.j3d.loaders.objectfile.ObjectFile;
import com.sun.j3d.loaders.ParsingErrorException;
import com.sun.j3d.loaders.IncorrectFormatException;
import com.sun.j3d.utils.behaviors.mouse.*;
import com.sun.j3d.utils.behaviors.interpolators.*;

public class LightObject{
  public TransformGroup objTrans;
  private Group root;
  private BranchGroup bg;
  
      
    public LightObject(Group group){
	
	root = group;
	objTrans = new TransformGroup();

        objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
	objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
	Color3f light1Color = new Color3f(0.35f, 0.35f, 0.25f);
	Vector3f light1Direction  = new Vector3f(4.0f, -7.0f, -12.0f);
	Color3f light2Color = new Color3f(0.3f, 0.3f, 0.4f);
	Vector3f light2Direction  = new Vector3f(-6.0f, -2.0f, -1.0f);
	Color3f bgColor    = new Color3f(1.0f, 1.0f, 1.0f);
    BoundingSphere bounds =
      new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);
    Background bgNode = new Background(bgColor);
    bgNode.setApplicationBounds(bounds);
    

	bg = new BranchGroup();
	bg.setCapability(BranchGroup.ALLOW_DETACH);
	bg.addChild(objTrans);
	bg.addChild(bgNode);
	DirectionalLight dlight1 = new DirectionalLight(light1Color, light1Direction);
	dlight1.setInfluencingBounds(bounds);
	bg.addChild(dlight1);
    
   
	DirectionalLight dlight2  = new DirectionalLight(light2Color, light2Direction);
	dlight2.setInfluencingBounds(bounds);
	bg.addChild(dlight2);
	
	bg.compile(); 
	
	root.addChild(bg);
    }
    public void unbind() {
      bg.detach();
    }
}
