import java.awt.*;
import java.applet.*;
import java.util.*;
import java.awt.event.*;
import java.io.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class Polyhedron{
    
    TriangleMesh odata=null;
    double aveedgel=1.0;
    double [] dist;
    double [] sim;
    
  
    public Polyhedron(){
    }
  public int getNearlestV(Point3d in){
      int i;
      double dval;
      double minVal = odata.Distance(odata.point[0],in);
      int MinID=0;
      for(i=1;i<odata.numberV;i++){
	dval = odata.Distance(odata.point[i],in);
	if(dval<minVal){
	  minVal = dval;
	  MinID = i;
	}
      }
      //System.out.println(+MinID+" "+in.x+" "+in.y+" "+in.z);
      return MinID;
      
    }
    public void setAveEdgeLength(){
      int i;aveedgel=0.0;PointTool PT = new PointTool();
      for(i=0;i<odata.numberF;i++){
	aveedgel += (PT.Distance(odata.point[odata.Face[i][0]],odata.point[odata.Face[i][1]])+PT.Distance(odata.point[odata.Face[i][1]],odata.point[odata.Face[i][2]])+PT.Distance(odata.point[odata.Face[i][2]],odata.point[odata.Face[i][0]]))/3.0;
  }
  
 aveedgel /= ((double)(odata.numberF));
  if(aveedgel==0.0)aveedgel=1.0;
	
      
    
    }
    public void Error(){
      int i,j;
      double entopy=0.0;
      double Maxerror=0.0;
      double Aveerror=0.0;
      double [] hist = new double[256];
      
     
      for(i=0;i<odata.numberV;i++){
	dist[i] = Distance(odata.KnotInit[i],odata.point[i]);
	odata.H[i] = dist[i];
	Aveerror += dist[i];
	if(Maxerror<dist[i])Maxerror=dist[i];
	
      }
      Aveerror /= ((double)(odata.numberV));
      double mdiv = 1.0;
      if(Maxerror!=0.0){
	mdiv = 1.0/Maxerror;
      }
      mdiv *= 255.0;
      int hid=0;
      double prob = 1.0/((double)(odata.numberV));
      for(i=0;i<odata.numberV;i++){
	hid = ((int)(((double)(mdiv*dist[i]))));
	if(hid<0)hid=0;
	if(hid>255)hid=255;
	hist[hid]+=prob;
      }
      
      entopy = 0.0;
      for(i=0;i<256;i++){
	
	entopy += -hist[i]*Math.log((0.00000001+hist[i]));
      
      }
      
      //odata.setColorPrHBipolar();//
      //odata.resetHinfo();
      odata.DistanceColoring(dist);
      
      System.out.println("Max: "+Maxerror);
      System.out.println("Average: "+Aveerror);
      System.out.println("Entropy: "+entopy);
      
      

      
    }
    
    public void ApplySmoothing(int Stype,double Sig1,double Sig2,double Sig3,int num,int pickID,int opt,Choice ie){
	
	
	String filename1 = new String("tempfile1.txt");
	String filename2 = new String("tempfile2.txt");
	int i,j;
	double d1,d2,d3,d4,runtime;
	
	
	String command = new String("./Smoothing "+filename1+" "+filename2);
	try{
	    FileOutputStream output = 
		new FileOutputStream(filename1);
	    PrintWriter pwp = new PrintWriter(output);
	    pwp.println(Stype+" "+num+" "+pickID+" "+opt);
	    pwp.println(Sig1+" "+Sig2+" "+Sig3);
	    pwp.println(odata.numberV);
	    pwp.println(odata.numberF);
	    for(i=0;i<odata.numberV;i++){
	      pwp.println(odata.point[i].x+" "+odata.point[i].y+" "+odata.point[i].z); 
	    }
	    for(i=0;i<odata.numberF;i++){
	      pwp.println(odata.Face[i][0]+" "+odata.Face[i][1]+" "+odata.Face[i][2]);
	    }
	    
	    pwp.close();
	    output.close();
	}catch (IOException e){
	  System.out.println("IOException");
	  
	}
	
	Process proc=null;
	try{
	  proc = Runtime.getRuntime().exec(command);
	  try{
	    int exitCode = proc.waitFor();
	  }catch (InterruptedException e){
	    System.out.println("InterruptedExceptione in ApplySmoothing Process");
	  }
	}catch (IOException e){
	  System.out.println("IOException in ApplySmoothing Process");
	}catch (SecurityException e){
	  System.out.println("SecurityException in ApplySmoothing Process");
	}
	if(Stype==0){
	    try{
	  FileInputStream  input = 
	    new FileInputStream (filename2);
	  LineNumberReader lnr = 
	    new LineNumberReader(new BufferedReader(new InputStreamReader(input)));
	  StringTokenizer st;
	  
	  
	  
	  st = new StringTokenizer(lnr.readLine());
	  int dnumV = (Integer.valueOf(st.nextToken())).intValue();
	   
	  for(i=0;i<dnumV;i++){
	    if(!st.hasMoreTokens())
	      st = new StringTokenizer(lnr.readLine());
	    d1 = (Double.valueOf(st.nextToken())).doubleValue();
	    sim[i] = d1;
	    
	  }

	  try {
	      if(ie.getSelectedObjects()[0] == "Constant"){
		  odata.myobj.setColor(true);
	      }else if(ie.getSelectedObjects()[0] == "Similarity"){
		  
		  odata.SimilarityColoring(sim);
		  
	      }else if(ie.getSelectedObjects()[0] == "Mean Curvature"){
		  
		  
		  
		  odata.MeanCurvatureColoring();
		  
	      }else if(ie.getSelectedObjects()[0] == "Method Noise"){
		  odata.DistanceColoring(dist);
		  
	      }
	  
	    } catch (Exception e) {
		System.err.println ("Exception " + e);
	    }

	  odata.UpdatePolygon();
	  
	  lnr.close();
	  input.close();
	}catch (IOException e){
	  System.out.println("IOException");
	  
	}
	
        
	}else{
	  double maxdiff=0.0;
	  try{
	    FileInputStream  input = 
	      new FileInputStream (filename2);
	    LineNumberReader lnr = 
	      new LineNumberReader(new BufferedReader(new InputStreamReader(input)));
	    StringTokenizer st;
	    
	    
	    
	    st = new StringTokenizer(lnr.readLine());
	    int dnumV = (Integer.valueOf(st.nextToken())).intValue();
	    
	    
	    for(i=0;i<dnumV;i++){
	      if(!st.hasMoreTokens())
		st = new StringTokenizer(lnr.readLine());
	      d1 = (Double.valueOf(st.nextToken())).doubleValue();
	      if(!st.hasMoreTokens())
		st = new StringTokenizer(lnr.readLine());
	      d2 = (Double.valueOf(st.nextToken())).doubleValue();
	      if(!st.hasMoreTokens())
		st = new StringTokenizer(lnr.readLine());
	      d3 = (Double.valueOf(st.nextToken())).doubleValue();
	      
	      
	      odata.point[i].x = d1;
	      odata.point[i].y = d2;
	      odata.point[i].z = d3;
	      dist[i] = Distance(odata.point[i],odata.KnotInit[i]);
	    if(maxdiff<dist[i])maxdiff = dist[i];
	    }
	    if(maxdiff>0.0){
	      for(i=0;i<odata.numberV;i++){
		dist[i] /= maxdiff;
	      }
	      
	  }
	  odata.calMeanCurvature();
	  try {
	      if(ie.getSelectedObjects()[0] == "Constant"){
		  odata.myobj.setColor(true);
	      }else if(ie.getSelectedObjects()[0] == "Similarity"){
		  
		  odata.SimilarityColoring(sim);
		  
	      }else if(ie.getSelectedObjects()[0] == "Mean Curvature"){
		  
		  
		  
		  odata.MeanCurvatureColoring();
		  
	      }else if(ie.getSelectedObjects()[0] == "Method Noise"){
		  odata.DistanceColoring(dist);
		  
	      }
	  
	    } catch (Exception e) {
		System.err.println ("Exception " + e);
	    }

	  
	  odata.UpdatePolygon();
	  
	  lnr.close();
	  input.close();
	}catch (IOException e){
	  System.out.println("IOException");
	  
	}
	
        }
    }
    


  
  
  public void Init(IDList h,IDList t)
    {
      h.next = new IDList();
      t.back = new IDList();
      h.next = t;
      t.back = h;
    }
   public IDList next(IDList now)
    {
      return (now.next);
    }
  public IDList back(IDList now)
    {
      return (now.back);
    }
  
  
  
public boolean ReadTPolyData(String filename){
    
    try{
      FileInputStream  input = 
	new FileInputStream (filename);
      
      LineNumberReader lnr = 
	new LineNumberReader(new BufferedReader(new InputStreamReader(input)));
      
      StringTokenizer st;
      
      
      int dnumV,dnumF;
      
      st = new StringTokenizer(lnr.readLine());
      dnumV = (Integer.valueOf(st.nextToken())).intValue();
      if(!st.hasMoreTokens())
	st = new StringTokenizer(lnr.readLine());
      dnumF = (Integer.valueOf(st.nextToken())).intValue();
      
     
      
      odata = new TriangleMesh();
      
      odata.memoryallocation(dnumV,dnumF);
     dist = new double[odata.numberV];
     sim = new double[odata.numberV];
      int i,j,k;
      
      //System.out.println("Init finish.");
      double dx,dy,dz;
       double maxvalue = 0.0;
       odata.maxX=0.0;
       odata.maxY=0.0;
       odata.maxZ=0.0;
       odata.minX=0.0;
       odata.minY=0.0;
       odata.minZ=0.0;
       boolean firstcheck=true;
      for(i=0;i<odata.numberV;i++){
      if(!st.hasMoreTokens())
	st = new StringTokenizer(lnr.readLine());
      dx = (Double.valueOf(st.nextToken())).doubleValue();
      if(!st.hasMoreTokens())
	st = new StringTokenizer(lnr.readLine());
      dy = (Double.valueOf(st.nextToken())).doubleValue();
      if(!st.hasMoreTokens())
	st = new StringTokenizer(lnr.readLine());
      dz = (Double.valueOf(st.nextToken())).doubleValue();
      odata.InitializeData(i,dx,dy,dz);
      dist[i] = sim[i] = 0.0;
      if(firstcheck){
	  firstcheck =false;
	  odata.maxX = dx;
	  odata.maxY = dy;
	  odata.maxZ = dz;
	  odata.minX = dx;
	  odata.minY = dy;
	  odata.minZ = dz;
	  
	}else{
	  if(odata.maxX<dx)odata.maxX = dx;
	  if(odata.maxY<dy)odata.maxY = dy;
	  if(odata.maxZ<dz)odata.maxZ = dz;
	  if(odata.minX>dx)odata.minX = dx;
	  if(odata.minY>dy)odata.minY = dy;
	  if(odata.minZ>dz)odata.minZ = dz;
	  
	}
      if(maxvalue<Math.abs(dx))maxvalue = Math.abs(dx);
      if(maxvalue<Math.abs(dy))maxvalue = Math.abs(dy);
      if(maxvalue<Math.abs(dz))maxvalue = Math.abs(dz);
      
      }
      
      
      if(maxvalue != 0.0){
	odata.ReScale((1.0/maxvalue));
      }
      
      
	    
      int di,dj,dk;
      int dummm;
      for(i=0;i<odata.numberF;i++){
	if(!st.hasMoreTokens())
	  st = new StringTokenizer(lnr.readLine());
	dummm = (Integer.valueOf(st.nextToken())).intValue();
	if(!st.hasMoreTokens())
	  st = new StringTokenizer(lnr.readLine());
	di = (Integer.valueOf(st.nextToken())).intValue();
	if(!st.hasMoreTokens())
	  st = new StringTokenizer(lnr.readLine());
	dj = (Integer.valueOf(st.nextToken())).intValue();
	if(!st.hasMoreTokens())
	  st = new StringTokenizer(lnr.readLine());
	dk = (Integer.valueOf(st.nextToken())).intValue();
	
	odata.MakeFace(i,di,dj,dk);
      }
      odata.MakeArrayObj(3);
      odata.SetBoundaryStrips();
      odata.setEdgeN();
      odata.setMeanCurvature();
      setAveEdgeLength();
      
      return true;
     }catch (IOException e){
      System.out.println("IOException");
      return false;
    }
  }
 

 public void ReadTPolyDataSP(String filename){
    
    try{
      FileInputStream  input = 
	new FileInputStream (filename);
      
      LineNumberReader lnr = 
	new LineNumberReader(new BufferedReader(new InputStreamReader(input)));
      
      StringTokenizer st;
      
      
      int dnumV,dnumF;
      double maxdiff=0.0;
      st = new StringTokenizer(lnr.readLine());
      dnumV = (Integer.valueOf(st.nextToken())).intValue();
      if(!st.hasMoreTokens())
	st = new StringTokenizer(lnr.readLine());
      dnumF = (Integer.valueOf(st.nextToken())).intValue();
      
     
      
     
      int i,j,k;
      
      //System.out.println("Init finish.");
      double dx,dy,dz;
      double maxvalue = 0.0;
      odata.maxX=0.0;
      odata.maxY=0.0;
      odata.maxZ=0.0;
       odata.minX=0.0;
       odata.minY=0.0;
       odata.minZ=0.0;
       boolean firstcheck=true;
       for(i=0;i<odata.numberV;i++){
	 if(!st.hasMoreTokens())
	   st = new StringTokenizer(lnr.readLine());
	 dx = (Double.valueOf(st.nextToken())).doubleValue();
	 if(!st.hasMoreTokens())
	   st = new StringTokenizer(lnr.readLine());
	 dy = (Double.valueOf(st.nextToken())).doubleValue();
	 if(!st.hasMoreTokens())
	   st = new StringTokenizer(lnr.readLine());
	 dz = (Double.valueOf(st.nextToken())).doubleValue();
	 odata.point[i].x = dx;
	 odata.point[i].y = dy;
	 odata.point[i].z = dz;
	 dist[i] = Distance(odata.point[i],odata.KnotInit[i]);
	 if(maxdiff<dist[i])maxdiff=dist[i];
	 sim[i] = 0.0;
       }
       if(maxdiff>0.0){
        for(i=0;i<odata.numberV;i++){
	    dist[i] /= maxdiff;
	}
       
       }

       odata.calMeanCurvature();
       
       
       
       odata.UpdatePolygon();
      
      
     }catch (IOException e){
      System.out.println("IOException");
      
    }
  }
 


  private double Distance(Point3d in1,Point3d in2){
    return Math.sqrt((((in1.x-in2.x)*(in1.x-in2.x))
		      +((in1.y-in2.y)*(in1.y-in2.y))
		      +((in1.z-in2.z)*(in1.z-in2.z))));
		      
  }
  public void OSubdivision(int stype,int numenettimes){
    
      odata.Subdivision(stype,numenettimes);
      
      
  }

  public void OInitE(){
    
  }
  
  
  public void ODecimation(double dv){
    
    odata.Decimation(dv);
    
  }

  

  public void OFlow(int ftype,int numenettimes){
          odata.Flow(ftype,numenettimes);
    
    
  }
  
  
  

}

