

import java.awt.*;
import java.applet.*;
import java.util.*;
import java.lang.*;
import java.awt.event.*;
import java.io.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class TMesh{
    
    int numberV=0;
    int numberF=0;
    ViewShape3D myobj=null;
    Point3d[] point = null;
    int[][] Face=null;
    
    double scaler=1.0;
    public TMesh(int dV,int dF,double dscaler){
	numberV=dV;
	numberF=dF;scaler = dscaler;
	point = new Point3d[numberV];
	Face = new int[numberF][3];
    }
    public void setV(int i,double dx,double dy,double dz){
      point[i] = new Point3d(dx,dy,dz);
    }
    public void setF(int i,int di,int dj,int dk){
      
	Face[i][0] = di;
	Face[i][1] = dj;
	Face[i][2] = dk;
	
    }
    
    public void MakeArrayObj(int dv){
	int i =0;
	myobj = new ViewShape3D(dv);      
	this.MakeArrayData();
    }
    public void MakeArrayData(){
	int i=0;
	int j=0;
	myobj.reNew(numberV,numberF,scaler);
	
	
	/* shading with normal
	Point3d [] normal = new Point3d[numberV];
	for(i=0;i<numberV;i++){
	  normal[i] = new Point3d(0.0,0.0,0.0);
	}
	Vector3d v1v3d = new Vector3d(0.0,0.0,0.0);
	Vector3d v2v3d = new Vector3d(0.0,0.0,0.0);
	
	Vector3d ddnormalv3d = new Vector3d(0.0,0.0,0.0);
	double [] weight = new double[3];
	double dsize1,dsize2;
	for(i=0;i<numberF;i++){
	  
	  v1v3d.x = point[Face[i][1]].x - point[Face[i][0]].x;
	  v1v3d.y = point[Face[i][1]].y - point[Face[i][0]].y;
	  v1v3d.z = point[Face[i][1]].z - point[Face[i][0]].z;
	  dsize1 = v1v3d.length();if(dsize1==0.0)dsize1=1.0;
	  v2v3d.x = point[Face[i][2]].x - point[Face[i][0]].x;
	  v2v3d.y = point[Face[i][2]].y - point[Face[i][0]].y;
	  v2v3d.z = point[Face[i][2]].z - point[Face[i][0]].z;
	  dsize2 = v2v3d.length();if(dsize2==0.0)dsize2=1.0;
	  weight[0] = 1.0/(dsize1*dsize1*dsize2*dsize2);
	  
	  ddnormalv3d.cross(v1v3d, v2v3d);
	  
	  v1v3d.x = point[Face[i][2]].x - point[Face[i][1]].x;
	  v1v3d.y = point[Face[i][2]].y - point[Face[i][1]].y;
	  v1v3d.z = point[Face[i][2]].z - point[Face[i][1]].z;
	  dsize1 = v1v3d.length();if(dsize1==0.0)dsize1=1.0;
	  v2v3d.x = point[Face[i][0]].x - point[Face[i][1]].x;
	  v2v3d.y = point[Face[i][0]].y - point[Face[i][1]].y;
	  v2v3d.z = point[Face[i][0]].z - point[Face[i][1]].z;
	  dsize2 = v2v3d.length();if(dsize2==0.0)dsize2=1.0;
	  weight[1] = 1.0/(dsize1*dsize1*dsize2*dsize2);
	  v1v3d.x = point[Face[i][0]].x - point[Face[i][2]].x;
	  v1v3d.y = point[Face[i][0]].y - point[Face[i][2]].y;
	  v1v3d.z = point[Face[i][0]].z - point[Face[i][2]].z;
	  dsize1 = v1v3d.length();if(dsize1==0.0)dsize1=1.0;
	  v2v3d.x = point[Face[i][1]].x - point[Face[i][2]].x;
	  v2v3d.y = point[Face[i][1]].y - point[Face[i][2]].y;
	  v2v3d.z = point[Face[i][1]].z - point[Face[i][2]].z;
	  dsize2 = v2v3d.length();if(dsize2==0.0)dsize2=1.0;
	  weight[2] = 1.0/(dsize1*dsize1*dsize2*dsize2);
	  
	  
	  //ddnormalv3d.normalize();
	  
	  
	  for(j=0;j<3;j++){
	    normal[Face[i][j]].x += weight[j]*ddnormalv3d.x;
	    normal[Face[i][j]].y += weight[j]*ddnormalv3d.y;
	    normal[Face[i][j]].z += weight[j]*ddnormalv3d.z;
	  }
	  
	}
	for(i=0;i<numberV;i++){
	  ddnormalv3d.x = normal[i].x;
	  ddnormalv3d.y = normal[i].y;
	  ddnormalv3d.z = normal[i].z;
	  ddnormalv3d.normalize();
	  normal[i].x = ddnormalv3d.x;
	  normal[i].y = ddnormalv3d.y;
	  normal[i].z = ddnormalv3d.z;
	  
	}
	
	for(j=0;j<numberF;j++){
	    myobj.MakeFaceN(j,Face[j][0],Face[j][1],Face[j][2],point,normal);
	    
	}
	*/
	for(j=0;j<numberF;j++){
	    myobj.MakeFace(j,Face[j][0],Face[j][1],Face[j][2],point);
	    
	}
	myobj.MakeArrayData();
    }
    

}
